# {{ ansible_managed }}

###############
# General
###############

auto lo
iface lo inet loopback
{% if lo is defined %}
    address {{ lo }}
{% endif %}

auto eth0
iface eth0
    address {{ ansible_host }}/24
    gateway {{ oob_gateway }}
    vrf mgmt

auto mgmt
iface mgmt
    address 127.0.0.1/8
    address ::1/128
    vrf-table auto

{% if aggregation_ports is defined %}
###############
# Bridge / Vlans
###############

auto bridge
iface bridge
    bridge-vlan-aware yes
    bridge-ports {{ 'peerlink ' if mlag is defined }}{{ aggregation_ports | join(' ') }}
    bridge-vids{% if svi is defined %}{% for vlan in svi %} {{ vlan }}{% endfor %}{% endif %}{% if ospf is defined %}{% for port in ospf %}{% if ospf[port].vlan is defined %} {{ ospf[port].vlan }}{% endif %}{% endfor %}{% endif %} {{ vlans | sort | join(' ') }}
{%   if stp_treeprio is defined %}
    mstpctl-treeprio {{ stp_treeprio }}
{%   endif %}

{% endif %}
{% if mlag is defined %}
###############
# MLAG
###############

auto peerlink
iface peerlink
    bond-slaves {{ mlag.members | join(' ') }}
    mtu 9216

auto peerlink.4094
iface peerlink.4094
    clagd-backup-ip {{ mlag.backup_ip }} vrf mgmt
    clagd-peer-ip linklocal
{%   if mlag.priority is defined %}
    clagd-priority {{ mlag.priority }}
{%   endif %}
    clagd-sys-mac {{ mlag.sys_mac }}

{% endif %}
{% if aggregation_ports is defined %}
####################
# Aggregation ports
####################

{%   for port in aggregation_ports %}
{%     if aggregation_ports[port].mlag is defined %}
{%       for member in aggregation_ports[port].members %}
auto {{ member }}
iface {{ member }}
{%       endfor %}

{%     endif %}
auto {{ port }}
iface {{ port }}
{%     if aggregation_ports[port].mtu is defined %}
    mtu {{ aggregation_ports[port].mtu }}
{%     else %}
    mtu 1500
{%     endif %}
{%     if aggregation_ports[port].alias is defined %}
    alias {{ aggregation_ports[port].alias }}
{%     endif %}
{%     if aggregation_ports[port].mlag is defined %}
    clag-id {{ aggregation_ports[port].mlag_id }}
    bond-slaves {{ aggregation_ports[port].members | join(' ') }}
{%     endif %}
{%     if aggregation_ports[port].untagged is defined and aggregation_ports[port].tagged is undefined %}
    bridge-access {{ aggregation_ports[port].untagged }}
{%     elif aggregation_ports[port].tagged is defined and aggregation_ports[port].tagged|length >= 1 %}
    bridge-pvid {{ aggregation_ports[port].untagged | default('2') }}
    bridge-vids {{ aggregation_ports[port].tagged | join(' ') }}
{%     elif aggregation_ports[port].trunk is defined and aggregation_ports[port].trunk is sameas true %}
    bridge-vids {{ vlans | sort | join(' ') }}
{%     endif %}

{%   endfor %}
{% endif %}
{% if svi is defined %}
###############
# SVIs
###############

{%   for vlan in svi %}
auto vlan{{ vlan }}
iface vlan{{ vlan }}
    address {{ svi[vlan].ipv4 }}
    vlan-id {{ vlan }}
    vlan-raw-device bridge
    address-virtual {{ svi[vlan].mac_virtual }} {{ svi[vlan].ipv4_virtual }}

{%   endfor %}
{% endif %}
{% if ospf is defined %}
###############
# OSPF ports
###############

{%   for port in ospf %}
auto {{ port }}
iface {{ port }}
{%     if ospf[port].vlan is defined %}
    address {{ ospf[port].router_address }}
    vlan-id {{ ospf[port].vlan }}
    vlan-raw-device bridge
{%     else %}
    address {{ ospf[port].router_address }}
{%     endif %}
{%     if ospf[port].mtu is defined %}
    mtu {{ ospf[port].mtu }}
{%     else %}
    mtu 1500
{%     endif %}

{%   endfor %}
{% endif %}
{% if bgp is defined %}
###############
# BGP ports
###############

{%   for port in bgp.ports %}
auto {{ port.name }}
iface {{ port.name }}
    address {{ port.subnet }}
{%     if port.mtu is defined %}
    mtu {{ port.mtu }}
{%     else %}
    mtu 1500
{%     endif %}

{%   endfor %}
{% endif %}
